/*******************************************************************************
 * Copyright (c) 2018 IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0
 *
 * Contributors:
 *     Arnaud Dieumegard (IRT Saint Exupéry) - initial API and implementation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.pseim.pseim;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Multiplicity Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement#getMultiplicityValue <em>Multiplicity Value</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement#getCardinalityElement <em>Cardinality Element</em>}</li>
 * </ul>
 *
 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getMultiplicityElement()
 * @model interface="true" abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='cardinalityAsElementOrMult'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot cardinalityAsElementOrMult='(not (cardinalityElement.oclIsUndefined())) implies multiplicityValue = 1'"
 * @generated
 */
public interface MultiplicityElement extends EObject {
	/**
	 * Returns the value of the '<em><b>Multiplicity Value</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Multiplicity Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Multiplicity Value</em>' attribute.
	 * @see #setMultiplicityValue(int)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getMultiplicityElement_MultiplicityValue()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getMultiplicityValue();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement#getMultiplicityValue <em>Multiplicity Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Multiplicity Value</em>' attribute.
	 * @see #getMultiplicityValue()
	 * @generated
	 */
	void setMultiplicityValue(int value);

	/**
	 * Returns the value of the '<em><b>Cardinality Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cardinality Element</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cardinality Element</em>' reference.
	 * @see #setCardinalityElement(CardinalityElement)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getMultiplicityElement_CardinalityElement()
	 * @model
	 * @generated
	 */
	CardinalityElement getCardinalityElement();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement#getCardinalityElement <em>Cardinality Element</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cardinality Element</em>' reference.
	 * @see #getCardinalityElement()
	 * @generated
	 */
	void setCardinalityElement(CardinalityElement value);

} // MultiplicityElement
