/*******************************************************************************
 * Copyright (c) 2018 IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0
 *
 * Contributors:
 *     Arnaud Dieumegard (IRT Saint Exupéry) - initial API and implementation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.pseim.pseim;

import com.irtsaintexupery.pseim.seim.Model;
import com.irtsaintexupery.pseim.seim.PropertyHolder;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Pattern</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getTypeHS <em>Type HS</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getTypeFailure <em>Type Failure</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getAlsoKnownAs <em>Also Known As</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getUsedTactics <em>Used Tactics</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getContext <em>Context</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getDomain <em>Domain</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#isIsSingleChannel <em>Is Single Channel</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getInterfaceElements <em>Interface Elements</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.Pattern#getCardinalityElements <em>Cardinality Elements</em>}</li>
 * </ul>
 *
 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern()
 * @model
 * @generated
 */
public interface Pattern extends Model {
	/**
	 * Returns the value of the '<em><b>Type HS</b></em>' attribute list.
	 * The list contents are of type {@link com.irtsaintexupery.pseim.pseim.PatternTypeHS}.
	 * The literals are from the enumeration {@link com.irtsaintexupery.pseim.pseim.PatternTypeHS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type HS</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type HS</em>' attribute list.
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeHS
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_TypeHS()
	 * @model ordered="false"
	 * @generated
	 */
	EList<PatternTypeHS> getTypeHS();

	/**
	 * Returns the value of the '<em><b>Type Failure</b></em>' attribute.
	 * The literals are from the enumeration {@link com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type Failure</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type Failure</em>' attribute.
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode
	 * @see #setTypeFailure(PatternTypeFailureMode)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_TypeFailure()
	 * @model
	 * @generated
	 */
	PatternTypeFailureMode getTypeFailure();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.Pattern#getTypeFailure <em>Type Failure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type Failure</em>' attribute.
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode
	 * @see #getTypeFailure()
	 * @generated
	 */
	void setTypeFailure(PatternTypeFailureMode value);

	/**
	 * Returns the value of the '<em><b>Also Known As</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Also Known As</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Also Known As</em>' attribute list.
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_AlsoKnownAs()
	 * @model ordered="false"
	 *        annotation="http://www.eclipse.org/OCL/Collection nullFree='false'"
	 * @generated
	 */
	EList<String> getAlsoKnownAs();

	/**
	 * Returns the value of the '<em><b>Used Tactics</b></em>' attribute list.
	 * The list contents are of type {@link com.irtsaintexupery.pseim.pseim.SafetyTactic}.
	 * The literals are from the enumeration {@link com.irtsaintexupery.pseim.pseim.SafetyTactic}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Used Tactics</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Used Tactics</em>' attribute list.
	 * @see com.irtsaintexupery.pseim.pseim.SafetyTactic
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_UsedTactics()
	 * @model ordered="false"
	 *        annotation="http://www.eclipse.org/OCL/Collection nullFree='false'"
	 * @generated
	 */
	EList<SafetyTactic> getUsedTactics();

	/**
	 * Returns the value of the '<em><b>Context</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Context</em>' attribute.
	 * @see #setContext(String)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_Context()
	 * @model
	 * @generated
	 */
	String getContext();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.Pattern#getContext <em>Context</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Context</em>' attribute.
	 * @see #getContext()
	 * @generated
	 */
	void setContext(String value);

	/**
	 * Returns the value of the '<em><b>Domain</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Domain</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Domain</em>' attribute.
	 * @see #setDomain(String)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_Domain()
	 * @model
	 * @generated
	 */
	String getDomain();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.Pattern#getDomain <em>Domain</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Domain</em>' attribute.
	 * @see #getDomain()
	 * @generated
	 */
	void setDomain(String value);

	/**
	 * Returns the value of the '<em><b>Is Single Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Single Channel</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Single Channel</em>' attribute.
	 * @see #setIsSingleChannel(boolean)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_IsSingleChannel()
	 * @model required="true"
	 * @generated
	 */
	boolean isIsSingleChannel();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.Pattern#isIsSingleChannel <em>Is Single Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Single Channel</em>' attribute.
	 * @see #isIsSingleChannel()
	 * @generated
	 */
	void setIsSingleChannel(boolean value);

	/**
	 * Returns the value of the '<em><b>Interface Elements</b></em>' reference list.
	 * The list contents are of type {@link com.irtsaintexupery.pseim.seim.PropertyHolder}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Elements</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Elements</em>' reference list.
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_InterfaceElements()
	 * @model
	 * @generated
	 */
	EList<PropertyHolder> getInterfaceElements();

	/**
	 * Returns the value of the '<em><b>Cardinality Elements</b></em>' containment reference list.
	 * The list contents are of type {@link com.irtsaintexupery.pseim.pseim.CardinalityElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cardinality Elements</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cardinality Elements</em>' containment reference list.
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPattern_CardinalityElements()
	 * @model containment="true"
	 * @generated
	 */
	EList<CardinalityElement> getCardinalityElements();

} // Pattern
