/*******************************************************************************
 * Copyright (c) 2018 IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0
 *
 * Contributors:
 *     Arnaud Dieumegard (IRT Saint Exupéry) - initial API and implementation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.pseim.pseim;

import com.irtsaintexupery.pseim.seim.Component;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Pattern Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.PatternComponent#isMergeContent <em>Merge Content</em>}</li>
 * </ul>
 *
 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPatternComponent()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='contentIsPatternContent'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot contentIsPatternContent='content-&gt;forAll(c | c.oclIsTypeOf(PatternComponent) or c.oclIsTypeOf(PatternPort) or c.oclIsTypeOf(PatternLink))'"
 * @generated
 */
public interface PatternComponent extends MultiplicityElement, IdentifiedElement, Component {
	/**
	 * Returns the value of the '<em><b>Merge Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Merge Content</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Merge Content</em>' attribute.
	 * @see #setMergeContent(boolean)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPatternComponent_MergeContent()
	 * @model required="true"
	 * @generated
	 */
	boolean isMergeContent();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.PatternComponent#isMergeContent <em>Merge Content</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Merge Content</em>' attribute.
	 * @see #isMergeContent()
	 * @generated
	 */
	void setMergeContent(boolean value);

} // PatternComponent
