/*******************************************************************************
 * Copyright (c) 2018 IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0
 *
 * Contributors:
 *     Arnaud Dieumegard (IRT Saint Exupéry) - initial API and implementation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.pseim.pseim;

import com.irtsaintexupery.pseim.seim.Link;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Pattern Link</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.PatternLink#getLinkType <em>Link Type</em>}</li>
 *   <li>{@link com.irtsaintexupery.pseim.pseim.PatternLink#getElement <em>Element</em>}</li>
 * </ul>
 *
 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPatternLink()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='srcIsPatternPort dstIsPatternPort'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot srcIsPatternPort='src.oclIsTypeOf(PatternPort)' dstIsPatternPort='dst.oclIsTypeOf(PatternPort)'"
 * @generated
 */
public interface PatternLink extends IdentifiedElement, Link {
	/**
	 * Returns the value of the '<em><b>Link Type</b></em>' attribute.
	 * The literals are from the enumeration {@link com.irtsaintexupery.pseim.pseim.LinkType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Link Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Link Type</em>' attribute.
	 * @see com.irtsaintexupery.pseim.pseim.LinkType
	 * @see #setLinkType(LinkType)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPatternLink_LinkType()
	 * @model required="true"
	 * @generated
	 */
	LinkType getLinkType();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.PatternLink#getLinkType <em>Link Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Link Type</em>' attribute.
	 * @see com.irtsaintexupery.pseim.pseim.LinkType
	 * @see #getLinkType()
	 * @generated
	 */
	void setLinkType(LinkType value);

	/**
	 * Returns the value of the '<em><b>Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Element</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Element</em>' reference.
	 * @see #setElement(CardinalityElement)
	 * @see com.irtsaintexupery.pseim.pseim.PseimPackage#getPatternLink_Element()
	 * @model
	 * @generated
	 */
	CardinalityElement getElement();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.pseim.pseim.PatternLink#getElement <em>Element</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Element</em>' reference.
	 * @see #getElement()
	 * @generated
	 */
	void setElement(CardinalityElement value);

} // PatternLink
