/*******************************************************************************
 * Copyright (c) 2018 IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0
 *
 * Contributors:
 *     Arnaud Dieumegard (IRT Saint Exupéry) - initial API and implementation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.pseim.pseim;

import com.irtsaintexupery.pseim.seim.SeimPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.irtsaintexupery.pseim.pseim.PseimFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import ecore='http://www.eclipse.org/emf/2002/Ecore' seim='seim.ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface PseimPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "pseim";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.irt-saintexupery.com/pseim/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "pseim";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PseimPackage eINSTANCE = com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.impl.LibraryImpl <em>Library</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.impl.LibraryImpl
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getLibrary()
	 * @generated
	 */
	int LIBRARY = 0;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIBRARY__UID = SeimPackage.NAMED_ELEMENT__UID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIBRARY__NAME = SeimPackage.NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIBRARY__PATTERNS = SeimPackage.NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Library</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIBRARY_FEATURE_COUNT = SeimPackage.NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Library</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIBRARY_OPERATION_COUNT = SeimPackage.NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternImpl <em>Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.impl.PatternImpl
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPattern()
	 * @generated
	 */
	int PATTERN = 1;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__UID = SeimPackage.MODEL__UID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__NAME = SeimPackage.MODEL__NAME;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__PROPERTIES = SeimPackage.MODEL__PROPERTIES;

	/**
	 * The feature id for the '<em><b>Model Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__MODEL_ELEMENTS = SeimPackage.MODEL__MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Type HS</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__TYPE_HS = SeimPackage.MODEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type Failure</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__TYPE_FAILURE = SeimPackage.MODEL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Also Known As</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__ALSO_KNOWN_AS = SeimPackage.MODEL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Used Tactics</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__USED_TACTICS = SeimPackage.MODEL_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Context</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__CONTEXT = SeimPackage.MODEL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Domain</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__DOMAIN = SeimPackage.MODEL_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Is Single Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__IS_SINGLE_CHANNEL = SeimPackage.MODEL_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Interface Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__INTERFACE_ELEMENTS = SeimPackage.MODEL_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Cardinality Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN__CARDINALITY_ELEMENTS = SeimPackage.MODEL_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_FEATURE_COUNT = SeimPackage.MODEL_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_OPERATION_COUNT = SeimPackage.MODEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.impl.CardinalityElementImpl <em>Cardinality Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.impl.CardinalityElementImpl
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getCardinalityElement()
	 * @generated
	 */
	int CARDINALITY_ELEMENT = 2;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARDINALITY_ELEMENT__UID = SeimPackage.PROPERTY_HOLDER__UID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARDINALITY_ELEMENT__NAME = SeimPackage.PROPERTY_HOLDER__NAME;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARDINALITY_ELEMENT__PROPERTIES = SeimPackage.PROPERTY_HOLDER__PROPERTIES;

	/**
	 * The feature id for the '<em><b>Calculated Via</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARDINALITY_ELEMENT__CALCULATED_VIA = SeimPackage.PROPERTY_HOLDER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Cardinality Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARDINALITY_ELEMENT_FEATURE_COUNT = SeimPackage.PROPERTY_HOLDER_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Cardinality Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARDINALITY_ELEMENT_OPERATION_COUNT = SeimPackage.PROPERTY_HOLDER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement <em>Multiplicity Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.MultiplicityElement
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getMultiplicityElement()
	 * @generated
	 */
	int MULTIPLICITY_ELEMENT = 6;

	/**
	 * The feature id for the '<em><b>Multiplicity Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_ELEMENT__MULTIPLICITY_VALUE = 0;

	/**
	 * The feature id for the '<em><b>Cardinality Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_ELEMENT__CARDINALITY_ELEMENT = 1;

	/**
	 * The number of structural features of the '<em>Multiplicity Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_ELEMENT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Multiplicity Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternComponentImpl <em>Pattern Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.impl.PatternComponentImpl
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternComponent()
	 * @generated
	 */
	int PATTERN_COMPONENT = 3;

	/**
	 * The feature id for the '<em><b>Multiplicity Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__MULTIPLICITY_VALUE = MULTIPLICITY_ELEMENT__MULTIPLICITY_VALUE;

	/**
	 * The feature id for the '<em><b>Cardinality Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__CARDINALITY_ELEMENT = MULTIPLICITY_ELEMENT__CARDINALITY_ELEMENT;

	/**
	 * The feature id for the '<em><b>Identified As</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__IDENTIFIED_AS = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__UID = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__NAME = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__PROPERTIES = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Content</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__CONTENT = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Merge Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT__MERGE_CONTENT = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Pattern Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT_FEATURE_COUNT = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Pattern Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_COMPONENT_OPERATION_COUNT = MULTIPLICITY_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternPortImpl <em>Pattern Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.impl.PatternPortImpl
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternPort()
	 * @generated
	 */
	int PATTERN_PORT = 4;

	/**
	 * The feature id for the '<em><b>Multiplicity Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__MULTIPLICITY_VALUE = MULTIPLICITY_ELEMENT__MULTIPLICITY_VALUE;

	/**
	 * The feature id for the '<em><b>Cardinality Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__CARDINALITY_ELEMENT = MULTIPLICITY_ELEMENT__CARDINALITY_ELEMENT;

	/**
	 * The feature id for the '<em><b>Identified As</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__IDENTIFIED_AS = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__UID = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__NAME = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__PROPERTIES = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__DIRECTION = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Dir</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT__DIR = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Pattern Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT_FEATURE_COUNT = MULTIPLICITY_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Pattern Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_PORT_OPERATION_COUNT = MULTIPLICITY_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.IdentifiedElement <em>Identified Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.IdentifiedElement
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getIdentifiedElement()
	 * @generated
	 */
	int IDENTIFIED_ELEMENT = 7;

	/**
	 * The feature id for the '<em><b>Identified As</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIED_ELEMENT__IDENTIFIED_AS = 0;

	/**
	 * The number of structural features of the '<em>Identified Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIED_ELEMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Identified Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIED_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternLinkImpl <em>Pattern Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.impl.PatternLinkImpl
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternLink()
	 * @generated
	 */
	int PATTERN_LINK = 5;

	/**
	 * The feature id for the '<em><b>Identified As</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__IDENTIFIED_AS = IDENTIFIED_ELEMENT__IDENTIFIED_AS;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__UID = IDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__NAME = IDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__PROPERTIES = IDENTIFIED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Src</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__SRC = IDENTIFIED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__DST = IDENTIFIED_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Link Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__LINK_TYPE = IDENTIFIED_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK__ELEMENT = IDENTIFIED_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Pattern Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK_FEATURE_COUNT = IDENTIFIED_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Pattern Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_LINK_OPERATION_COUNT = IDENTIFIED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.PatternTypeHS <em>Pattern Type HS</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeHS
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternTypeHS()
	 * @generated
	 */
	int PATTERN_TYPE_HS = 8;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode <em>Pattern Type Failure Mode</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternTypeFailureMode()
	 * @generated
	 */
	int PATTERN_TYPE_FAILURE_MODE = 9;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.SafetyTactic <em>Safety Tactic</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.SafetyTactic
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getSafetyTactic()
	 * @generated
	 */
	int SAFETY_TACTIC = 10;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.LinkType <em>Link Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.LinkType
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getLinkType()
	 * @generated
	 */
	int LINK_TYPE = 11;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.pseim.pseim.PatternPortDirection <em>Pattern Port Direction</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.pseim.pseim.PatternPortDirection
	 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternPortDirection()
	 * @generated
	 */
	int PATTERN_PORT_DIRECTION = 12;

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.Library <em>Library</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Library</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Library
	 * @generated
	 */
	EClass getLibrary();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.pseim.pseim.Library#getPatterns <em>Patterns</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Patterns</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Library#getPatterns()
	 * @see #getLibrary()
	 * @generated
	 */
	EReference getLibrary_Patterns();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.Pattern <em>Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern
	 * @generated
	 */
	EClass getPattern();

	/**
	 * Returns the meta object for the attribute list '{@link com.irtsaintexupery.pseim.pseim.Pattern#getTypeHS <em>Type HS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Type HS</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getTypeHS()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_TypeHS();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.Pattern#getTypeFailure <em>Type Failure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type Failure</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getTypeFailure()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_TypeFailure();

	/**
	 * Returns the meta object for the attribute list '{@link com.irtsaintexupery.pseim.pseim.Pattern#getAlsoKnownAs <em>Also Known As</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Also Known As</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getAlsoKnownAs()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_AlsoKnownAs();

	/**
	 * Returns the meta object for the attribute list '{@link com.irtsaintexupery.pseim.pseim.Pattern#getUsedTactics <em>Used Tactics</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Used Tactics</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getUsedTactics()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_UsedTactics();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.Pattern#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Context</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getContext()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_Context();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.Pattern#getDomain <em>Domain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Domain</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getDomain()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_Domain();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.Pattern#isIsSingleChannel <em>Is Single Channel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Single Channel</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#isIsSingleChannel()
	 * @see #getPattern()
	 * @generated
	 */
	EAttribute getPattern_IsSingleChannel();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.pseim.pseim.Pattern#getInterfaceElements <em>Interface Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Interface Elements</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getInterfaceElements()
	 * @see #getPattern()
	 * @generated
	 */
	EReference getPattern_InterfaceElements();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.pseim.pseim.Pattern#getCardinalityElements <em>Cardinality Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cardinality Elements</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.Pattern#getCardinalityElements()
	 * @see #getPattern()
	 * @generated
	 */
	EReference getPattern_CardinalityElements();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.CardinalityElement <em>Cardinality Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cardinality Element</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.CardinalityElement
	 * @generated
	 */
	EClass getCardinalityElement();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.pseim.pseim.CardinalityElement#getCalculatedVia <em>Calculated Via</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Calculated Via</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.CardinalityElement#getCalculatedVia()
	 * @see #getCardinalityElement()
	 * @generated
	 */
	EReference getCardinalityElement_CalculatedVia();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.PatternComponent <em>Pattern Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern Component</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternComponent
	 * @generated
	 */
	EClass getPatternComponent();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.PatternComponent#isMergeContent <em>Merge Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Merge Content</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternComponent#isMergeContent()
	 * @see #getPatternComponent()
	 * @generated
	 */
	EAttribute getPatternComponent_MergeContent();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.PatternPort <em>Pattern Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern Port</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternPort
	 * @generated
	 */
	EClass getPatternPort();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.PatternPort#getDir <em>Dir</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dir</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternPort#getDir()
	 * @see #getPatternPort()
	 * @generated
	 */
	EAttribute getPatternPort_Dir();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.PatternLink <em>Pattern Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern Link</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternLink
	 * @generated
	 */
	EClass getPatternLink();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.PatternLink#getLinkType <em>Link Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Link Type</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternLink#getLinkType()
	 * @see #getPatternLink()
	 * @generated
	 */
	EAttribute getPatternLink_LinkType();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.pseim.pseim.PatternLink#getElement <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Element</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternLink#getElement()
	 * @see #getPatternLink()
	 * @generated
	 */
	EReference getPatternLink_Element();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement <em>Multiplicity Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Multiplicity Element</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.MultiplicityElement
	 * @generated
	 */
	EClass getMultiplicityElement();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement#getMultiplicityValue <em>Multiplicity Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplicity Value</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.MultiplicityElement#getMultiplicityValue()
	 * @see #getMultiplicityElement()
	 * @generated
	 */
	EAttribute getMultiplicityElement_MultiplicityValue();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement#getCardinalityElement <em>Cardinality Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cardinality Element</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.MultiplicityElement#getCardinalityElement()
	 * @see #getMultiplicityElement()
	 * @generated
	 */
	EReference getMultiplicityElement_CardinalityElement();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.pseim.pseim.IdentifiedElement <em>Identified Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identified Element</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.IdentifiedElement
	 * @generated
	 */
	EClass getIdentifiedElement();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.pseim.pseim.IdentifiedElement#getIdentifiedAs <em>Identified As</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Identified As</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.IdentifiedElement#getIdentifiedAs()
	 * @see #getIdentifiedElement()
	 * @generated
	 */
	EReference getIdentifiedElement_IdentifiedAs();

	/**
	 * Returns the meta object for enum '{@link com.irtsaintexupery.pseim.pseim.PatternTypeHS <em>Pattern Type HS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Pattern Type HS</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeHS
	 * @generated
	 */
	EEnum getPatternTypeHS();

	/**
	 * Returns the meta object for enum '{@link com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode <em>Pattern Type Failure Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Pattern Type Failure Mode</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode
	 * @generated
	 */
	EEnum getPatternTypeFailureMode();

	/**
	 * Returns the meta object for enum '{@link com.irtsaintexupery.pseim.pseim.SafetyTactic <em>Safety Tactic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Safety Tactic</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.SafetyTactic
	 * @generated
	 */
	EEnum getSafetyTactic();

	/**
	 * Returns the meta object for enum '{@link com.irtsaintexupery.pseim.pseim.LinkType <em>Link Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Link Type</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.LinkType
	 * @generated
	 */
	EEnum getLinkType();

	/**
	 * Returns the meta object for enum '{@link com.irtsaintexupery.pseim.pseim.PatternPortDirection <em>Pattern Port Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Pattern Port Direction</em>'.
	 * @see com.irtsaintexupery.pseim.pseim.PatternPortDirection
	 * @generated
	 */
	EEnum getPatternPortDirection();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PseimFactory getPseimFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.impl.LibraryImpl <em>Library</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.impl.LibraryImpl
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getLibrary()
		 * @generated
		 */
		EClass LIBRARY = eINSTANCE.getLibrary();

		/**
		 * The meta object literal for the '<em><b>Patterns</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LIBRARY__PATTERNS = eINSTANCE.getLibrary_Patterns();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternImpl <em>Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.impl.PatternImpl
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPattern()
		 * @generated
		 */
		EClass PATTERN = eINSTANCE.getPattern();

		/**
		 * The meta object literal for the '<em><b>Type HS</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__TYPE_HS = eINSTANCE.getPattern_TypeHS();

		/**
		 * The meta object literal for the '<em><b>Type Failure</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__TYPE_FAILURE = eINSTANCE.getPattern_TypeFailure();

		/**
		 * The meta object literal for the '<em><b>Also Known As</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__ALSO_KNOWN_AS = eINSTANCE.getPattern_AlsoKnownAs();

		/**
		 * The meta object literal for the '<em><b>Used Tactics</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__USED_TACTICS = eINSTANCE.getPattern_UsedTactics();

		/**
		 * The meta object literal for the '<em><b>Context</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__CONTEXT = eINSTANCE.getPattern_Context();

		/**
		 * The meta object literal for the '<em><b>Domain</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__DOMAIN = eINSTANCE.getPattern_Domain();

		/**
		 * The meta object literal for the '<em><b>Is Single Channel</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN__IS_SINGLE_CHANNEL = eINSTANCE.getPattern_IsSingleChannel();

		/**
		 * The meta object literal for the '<em><b>Interface Elements</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PATTERN__INTERFACE_ELEMENTS = eINSTANCE.getPattern_InterfaceElements();

		/**
		 * The meta object literal for the '<em><b>Cardinality Elements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PATTERN__CARDINALITY_ELEMENTS = eINSTANCE.getPattern_CardinalityElements();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.impl.CardinalityElementImpl <em>Cardinality Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.impl.CardinalityElementImpl
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getCardinalityElement()
		 * @generated
		 */
		EClass CARDINALITY_ELEMENT = eINSTANCE.getCardinalityElement();

		/**
		 * The meta object literal for the '<em><b>Calculated Via</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CARDINALITY_ELEMENT__CALCULATED_VIA = eINSTANCE.getCardinalityElement_CalculatedVia();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternComponentImpl <em>Pattern Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.impl.PatternComponentImpl
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternComponent()
		 * @generated
		 */
		EClass PATTERN_COMPONENT = eINSTANCE.getPatternComponent();

		/**
		 * The meta object literal for the '<em><b>Merge Content</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN_COMPONENT__MERGE_CONTENT = eINSTANCE.getPatternComponent_MergeContent();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternPortImpl <em>Pattern Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.impl.PatternPortImpl
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternPort()
		 * @generated
		 */
		EClass PATTERN_PORT = eINSTANCE.getPatternPort();

		/**
		 * The meta object literal for the '<em><b>Dir</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN_PORT__DIR = eINSTANCE.getPatternPort_Dir();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.impl.PatternLinkImpl <em>Pattern Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.impl.PatternLinkImpl
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternLink()
		 * @generated
		 */
		EClass PATTERN_LINK = eINSTANCE.getPatternLink();

		/**
		 * The meta object literal for the '<em><b>Link Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PATTERN_LINK__LINK_TYPE = eINSTANCE.getPatternLink_LinkType();

		/**
		 * The meta object literal for the '<em><b>Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PATTERN_LINK__ELEMENT = eINSTANCE.getPatternLink_Element();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.MultiplicityElement <em>Multiplicity Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.MultiplicityElement
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getMultiplicityElement()
		 * @generated
		 */
		EClass MULTIPLICITY_ELEMENT = eINSTANCE.getMultiplicityElement();

		/**
		 * The meta object literal for the '<em><b>Multiplicity Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MULTIPLICITY_ELEMENT__MULTIPLICITY_VALUE = eINSTANCE.getMultiplicityElement_MultiplicityValue();

		/**
		 * The meta object literal for the '<em><b>Cardinality Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MULTIPLICITY_ELEMENT__CARDINALITY_ELEMENT = eINSTANCE.getMultiplicityElement_CardinalityElement();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.IdentifiedElement <em>Identified Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.IdentifiedElement
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getIdentifiedElement()
		 * @generated
		 */
		EClass IDENTIFIED_ELEMENT = eINSTANCE.getIdentifiedElement();

		/**
		 * The meta object literal for the '<em><b>Identified As</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IDENTIFIED_ELEMENT__IDENTIFIED_AS = eINSTANCE.getIdentifiedElement_IdentifiedAs();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.PatternTypeHS <em>Pattern Type HS</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.PatternTypeHS
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternTypeHS()
		 * @generated
		 */
		EEnum PATTERN_TYPE_HS = eINSTANCE.getPatternTypeHS();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode <em>Pattern Type Failure Mode</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.PatternTypeFailureMode
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternTypeFailureMode()
		 * @generated
		 */
		EEnum PATTERN_TYPE_FAILURE_MODE = eINSTANCE.getPatternTypeFailureMode();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.SafetyTactic <em>Safety Tactic</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.SafetyTactic
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getSafetyTactic()
		 * @generated
		 */
		EEnum SAFETY_TACTIC = eINSTANCE.getSafetyTactic();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.LinkType <em>Link Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.LinkType
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getLinkType()
		 * @generated
		 */
		EEnum LINK_TYPE = eINSTANCE.getLinkType();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.pseim.pseim.PatternPortDirection <em>Pattern Port Direction</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.pseim.pseim.PatternPortDirection
		 * @see com.irtsaintexupery.pseim.pseim.impl.PseimPackageImpl#getPatternPortDirection()
		 * @generated
		 */
		EEnum PATTERN_PORT_DIRECTION = eINSTANCE.getPatternPortDirection();

	}

} //PseimPackage
